;Programme par Denis Duplan (denis_duplan@yahoo.fr)
;Cette oeuvre est mise  disposition selon les termes de la Licence Creative Commons Attribution (http://creativecommons.org/licenses/by-nc-sa/4.0/fr/) - Pas dUtilisation Commerciale - Partage dans les Mmes Conditions 4.0 France

;Coded by Yragael
	section prg,code_c
	include "sources:interpol3d/short_registers.s"
	include "sources:interpol3d/exec_lib.i"

;*************** PARAMETRES DE L'ECRAN ***************

NbPlane=4
SizeX=352
SizeY=200

StartX=116				;depart horizontal du trac
StartY=45				;depart vertical du trac

TraceX=SizeX				;largeur de l'image a tracer  ...
					;... partir de StartX

DisplayX=SizeX				;largeur de l'image a visualiser  ...
					;... partir de StartDisplayX
DisplayY=SizeY				;hauteur de l'image a visualiser  ...
					;... partir de StartY

StartDisplayX=StartX			;debut horizontal visible de l'image

StopX=DisplayX+StartDisplayX-256	;fin horizontale visible de l'image 
StopY=DisplayY+StartY-256		;fin verticale visible de l'image

DDF_Strt=(StartX-17)/2
DDF_Stop=DDF_Strt+(TraceX/2-8)

ModuloPair=(SizeX-TraceX)/8
ModuloImpair=(SizeX-TraceX)/8

PlaneSize=SizeY*SizeX/8

;*************** CONSTANTES ***************

Timer=100
DeltaX=3
DeltaY=2
Font3DHeight=80
CoorSize=4*4+10*4+8*4+17*4+16*4+14*4+12*4+8*4
MEMF_CLEAR=$10000
MEMF_CHIP=$2
MEMF_FAST=$4
CopSize=16*4+11*4+8*NbPlane+8+12+8*(NbPlane-1)+16+12+8+4

;16*4 (palette)
;11*4 (parametres ecran)
;8*NbPlane (adresses bitplanes, 1 partie)
;8 (wait, $0180)
;12 (copperline (wait, $0180, $0190))
;8*(NbPlane-1) (wait, adresses bitplanes, 2 partie)
;16 ($0182, $0184, $0192, $0194)
;12 (fin copperline (wait, $0180, $0190))
;8 (wait, $0180 noir)
;4 (FFFFFFFE)

;*************** MACROS ***************

;----- attente blitter -----

WAITBLIT:	macro
Wait_Blit0\@
		btst #14,DMACONR(a5)
		bne Wait_Blit0\@
Wait_Blit1\@
		btst #14,DMACONR(a5)
		bne Wait_Blit1\@
		endm

;----- attente VBL -----

WAITVBL:	macro
Wait_VBL\@
		cmp.b #$FF,VHPOSR(a5)
		bne Wait_VBL\@
		endm

;*************** PROGRAMME PRINCIPAL ***************

;+++++ la 3D est affichee a une marge verticale de 4 pixels du bord superieur
;+++++ de l'ecran

;----- intialisations -----

	bsr Init
		
;----- square background -----

	move.w #$0000,BLTCON1(a5)
	move.w #%0000010111001100,BLTCON0(a5)
	move.w #0,BLTBMOD(a5)
	move.w #(SizeX-32)/8,BLTDMOD(a5)
	move.l Plane3_adr,a0
	lea Square_adr,a1
	lea NOTSquare_adr,a2

	moveq #15-1,d0
Square_Loop:
	rept 11
	WAITBLIT
	move.l a0,BLTDPTH(a5)
	move.l a1,BLTBPTH(a5)
	move.w #2+16*64,BLTSIZE(a5)
	addq.w #4,a0
	endr
	exg a1,a2
	lea 15*SizeX/8(a0),a0
	dbf d0,Square_Loop

;----- texte page haut -----

	movea.l Plane0_adr,a0
	lea (Font3DHeight+8)*SizeX/8+4*SizeX/8+2(a0),a0
	lea Text_adr,a1
	lea Font8_adr,a2
	bsr TextWriter
	move.l a1,d1
	movea.l Plane1_adr,a0
	lea (Font3DHeight+8)*SizeX/8+4*SizeX/8+2(a0),a0
	lea Text_adr,a1
	lea Font8Mask_adr,a2
	bsr TextWriter

;----- texte page centre -----

	movea.l Plane0_adr,a0
	lea PlaneSize+4*SizeX/8+2(a0),a0
	movea.l d1,a1
	lea Font8_adr,a2
	bsr TextWriter
	movea.l Plane1_adr,a0
	lea PlaneSize+4*SizeX/8+2(a0),a0
	move.l d1,a1
	lea Font8Mask_adr,a2
	bsr TextWriter
	move.l a1,d1

;----- texte page bas -----

	movea.l Plane0_adr,a0
	lea PlaneSize+(SizeY-Font3DHeight-8)*SizeX/8+4*SizeX/8+2(a0),a0
	movea.l d1,a1
	lea Font8_adr,a2
	bsr TextWriter
	movea.l Plane1_adr,a0
	lea PlaneSize+(SizeY-Font3DHeight-8)*SizeX/8+4*SizeX/8+2(a0),a0
	movea.l d1,a1
	lea Font8Mask_adr,a2
	bsr TextWriter

;----- initialisation de parametres -----

	bsr mt_init
	move.l PlaneBuffer_adr,a0
	move.w #2*(360-DeltaX),AngleX
	move.w #2*(360-DeltaY),AngleY
	moveq #31,d4			;2 sortes de lignes de carres

	moveq #0,d1
	moveq #0,d2
	move.w #Timer-1,d3
	movem.w d1-d3,-(sp)

;----- programme principal -----

Main_Loop:
	WAITVBL

;----- music -----

	bsr mt_music

;----- hardscroll du texte -----

	movem.w (sp)+,d1-d3

	or.w d1,d1
	beq HardText_NoDOWN
	movea.l Cop_adr,a1
	lea 27*4+8*NbPlane+22(a1),a1
	move.w (a1),d0
	swap d0
	move.w 4(a1),d0
	addi.l #2*SizeX/8,d0
	move.w d0,4(a1)
	swap d0
	move.w d0,(a1)
	move.w 8(a1),d0
	swap d0
	move.w 12(a1),d0
	addi.l #2*SizeX/8,d0
	move.w d0,12(a1)
	swap d0
	move.w d0,8(a1)
	subq.w #1,d1
HardText_NoDOWN:

	or.w d2,d2
	beq HardText_NoUP
	movea.l Cop_adr,a1
	lea 27*4+8*NbPlane+22(a1),a1
	move.w (a1),d0
	swap d0
	move.w 4(a1),d0
	subi.l #2*SizeX/8,d0
	move.w d0,4(a1)
	swap d0
	move.w d0,(a1)
	move.w 8(a1),d0
	swap d0
	move.w 12(a1),d0
	subi.l #2*SizeX/8,d0
	move.w d0,12(a1)
	swap d0
	move.w d0,8(a1)
	subq.w #1,d2
HardText_NoUP:

	or.w d2,d2
	bne HardText_NoPage
	or.w d1,d1
	bne HardText_NoPage
	dbf d3,HardText_NoPage
	move.w #Timer-1,d3
	lea PageStrt_adr,a1
	move.w (a1),d2
	move.w 2(a1),d1
	move.l (a1),d0
	rept 3
	move.l 4(a1),(a1)+
	endr
	move.l d0,(a1)
HardText_NoPage:

	movem.w d1-d3,-(sp)

;----- swappe les bitplanes -----	

	WAITBLIT
	movea.l Cop_adr,a1
	move.w 27*4+18(a1),d0		;bpl2pth
	swap d0
	move.w 27*4+22(a1),d0		;bpl2ptl
	move.w 27*4+14(a1),27*4+22(a1)	;bpl2ptl<-bpl1ptl
	move.w 27*4+10(a1),27*4+18(a1)	;bpl2pth<-bpl1pth
	move.w 27*4+2(a1),27*4+10(a1)	;bpl1pth<-bpl0pth
	move.w 27*4+6(a1),27*4+14(a1)	;bpl1ptl<-bpl0ptl
	move.l a0,d1
	move.w d1,27*4+6(a1)
	swap d1
	move.w d1,27*4+2(a1)
	move.l d0,a0

;----- hardscroll bitplane 3 -----

	move.w 27*4+26(a1),d0
	swap d0
	move.w 27*4+30(a1),d0
	addi.l #SizeX/8,d0
	dbf d4,HardPlane3_NoLoop
	move.l Plane3_adr,d0
	moveq #31,d4
HardPlane3_NoLoop:
	move.w d0,27*4+30(a1)
	swap d0
	move.w d0,27*4+26(a1)

;----- efface le PlaneBuffer_adr de travail -----

;+++++ pour gagner du temps on n'efface que la partie utilisee du bitplane
;+++++ soit a peu pres fond3dsize lignes

	WAITBLIT
	move.w #$0000,BLTCON1(a5)
	move.w #%0000000111001100,BLTCON0(a5)
	move.w #$0000,BLTBDAT(a5)
	move.w #$0000,BLTDMOD(a5)
	lea 4*SizeX/8(a0),a1
	move.l a1,BLTDPTH(a5)
	move.w #SizeX/16+Font3DHeight*64,BLTSIZE(a5)

;------ effectue la rotation X ------

	move.w AngleX,d0
	subq.w #2*DeltaX,d0
	bge AngleX_OK
	move.w #2*(360-DeltaX),d0
AngleX_OK:
	move.w d0,AngleX

;------ effectue la rotation Y ------

	move.w AngleY,d0
	subq.w #2*DeltaY,d0
	bge AngleY_OK
	move.w #2*(360-DeltaY),d0
AngleY_OK:
	move.w d0,AngleY

;----- calcul les coordonnees -----

	lea Cosinus_adr,a4
	move.w AngleX,d0
	move.w (a4,d0.w),d2
	lea Sinus_adr,a4
	move.w AngleY,d0
	move.w (a4,d0.w),d3
	lea Scene_adr,a2
	movea.l Coor2D_adr,a1

	rept 4
	move.w (a2)+,d0
	add.w #-320,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 10
	move.w (a2)+,d0
	add.w #-240,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 8
	move.w (a2)+,d0
	add.w #-160,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 17
	move.w (a2)+,d0
	add.w #-80,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 16
	move.w (a2)+,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 14
	move.w (a2)+,d0
	add.w #80,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 12
	move.w (a2)+,d0
	add.w #160,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

	rept 8
	move.w (a2)+,d0
	add.w #240,d0
	move.w (a2)+,d1
	add.w #-Font3DHeight/2,d1
	muls d3,d1
	swap d1
	rol.l #1,d1
	muls d2,d0
	swap d0
	rol.l #1,d0
	asr.w #1,d0		;divise par 2 car lettres trop larges
	add.w #SizeX/2,d0
	add.w #Font3DHeight/2+4,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	endr

;----- trace les lignes -----

	WAITBLIT
	move.w #$FFFF,BLTBDAT(a5)
	lea Lines_adr,a1
	movea.l Coor2D_adr,a2
	move.w #SizeX/8,BLTCMOD(a5)
	move.w #SizeX/8,BLTDMOD(a5)
	move.w #$8000,BLTAFWM(a5)
	move.w #$8000,BLTADAT(a5)

	rept 4
	move.w (a1)+,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 10
	move.w (a1)+,d0
	add.w #4*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 8
	move.w (a1)+,d0
	add.w #4*4+10*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4+10*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 17
	move.w (a1)+,d0
	add.w #4*4+10*4+8*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4+10*4+8*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 16
	move.w (a1)+,d0
	add.w #4*4+10*4+8*4+17*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4+10*4+8*4+17*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 14
	move.w (a1)+,d0
	add.w #4*4+10*4+8*4+17*4+16*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4+10*4+8*4+17*4+16*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 12
	move.w (a1)+,d0
	add.w #4*4+10*4+8*4+17*4+16*4+14*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4+10*4+8*4+17*4+16*4+14*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

	rept 8
	move.w (a1)+,d0
	add.w #4*4+10*4+8*4+17*4+16*4+14*4+12*4,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	add.w #4*4+10*4+8*4+17*4+16*4+14*4+12*4,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

;----- remplissage de surface -----

;+++++ attention le compilateur ne lit pas de la meme facon:
;+++++ PlaneSize-2-(SizeY/2-80)*SizeX/8
;+++++ et:
;+++++ PlaneSize-(SizeY/2-80)*SizeX/8-2=PlaneSize-((SizeY/2-80)*SizeX/8-2) !

	WAITBLIT
	move.w #0,BLTBMOD(a5)
	move.w #0,BLTDMOD(a5)
	move.w #%0000010111001100,BLTCON0(a5)
	move.w #%0000000000001010,BLTCON1(a5)
	lea (Font3DHeight+4)*SizeX/8-2(a0),a1
	move.l a1,BLTBPTH(a5)
	move.l a1,BLTDPTH(a5)
	move.w #SizeX/16+64*Font3DHeight,BLTSIZE(a5)

;----- test de fin -----

	btst #6,$bfe001
	bne Main_Loop

;----- fin -----

	movem.w (sp)+,d1-d3
	bsr mt_end
	bsr End

	rts

;*************** TRACE DE DROITES ***************

;Entree:
;	A0=adresse bitplane
;	D0=Xi
;	D1=Yi
;	D2=Xf
;	D3=Yf

;A6,D5,D6

DrawLine:

;----- ordonnancement des points -----

	cmp.w d1,d3
	beq DrawLine_End
	bge DrawLine_UpDown
	exg d0,d2
	exg d1,d3
DrawLine_UpDown:
	subq.w #1,d3

;------ calcul adresse de depart de la droite -----
	
	moveq #0,d6
	move.w d1,d6
;	lsl.l #3,d6
;	move.l d6,d5
;	lsl.l #2,d5
;	add.l d5,d6		;d6=y1*nbre octets par ligne
	mulu #SizeX/8,d6
	add.l a0,d6		;+adresse depart bitplane
	moveq #0,d5
	move.w d0,d5
	lsr.w #3,d5
	bclr #0,d5
	add.l d5,d6		;+x1/8

;----- recherche de l'octant -----

	moveq #0,d5
	sub.w d1,d3	;d3=Dy=y2-y1
	bpl.b Dy_Pos
	bset #2,d5
	neg d3
Dy_Pos:	
	sub.w d0,d2	;d2=Dx=x2-x1
	bpl.b Dx_Pos
	bset #1,d5
	neg d2
Dx_Pos:
	cmp.w d3,d2	;Dx-Dy
	bpl.b DxDy_Pos
	bset #0,d5
	exg d3,d2	;ainsi d3=Pdelta et d2=Gdelta
DxDy_Pos:
	add.w d3,d3	;d3=2*Pdelta

;----- BLTCON0 -----
	
	and.w #$F,d0
	ror.w #4,d0
	or.w #$B4A,d0

;----- BLTCON1 -----

	lea Octant_adr,a6
	move.b (a6,d5.w),d5
	lsl #2,d5
	bset #0,d5
	bset #1,d5

;----- attente blitter -----

	WAITBLIT

;----- BLTCON1, BLTBMOD, BLTAPTL, BLTAMOD -----

	move.w d3,BLTBMOD(a5)
	sub.w d2,d3
	bge.s DrawLine_NoBit
	bset #6,d5
DrawLine_NoBit:
	move.w d3,BLTAPTL(a5)
	sub.w d2,d3
	move.w d3,BLTAMOD(a5)

;----- BLTSIZE -----

	lsl #6,d2
	add.w #66,d2

;----- lancement blitter -----

	move.w d5,BLTCON1(a5)
	move.w d0,BLTCON0(a5)
	move.l d6,BLTCPTH(a5)
	move.l d6,BLTDPTH(a5)
	move.w d2,BLTSIZE(a5)

;----- fin -----

DrawLine_End:

	rts

;*************** TEXT WRITER ***************

;Entree:
;	A0=adresse screen
;	A1=adresse texte
;	A2=adresse font

TextWriter:

	movea.l a0,a3
TextWriter_Loop:
	moveq #0,d0
	move.b (a1)+,d0
	cmp.b #$0A,d0			;fin de ligne ?
	beq TextWriter_NewLine
	cmp.b #$1B,d0			;fin de page ?
	beq TextWriter_NewPage
	sub.b #$20,d0
	lsl.w #3,d0
	movea.l a3,a6
	lea (a2,d0.w),a4
	rept 8
	move.b (a4)+,(a6)
	lea SizeX/8(a6),a6
	endr
	addq.w #1,a3			;caractere suivant
	bra TextWriter_Loop
TextWriter_NewLine:
	lea 8*SizeX/8(a0),a0		;passe a la ligne
	movea.l a0,a3
	bra TextWriter_Loop
TextWriter_NewPage:
	addq.l #1,a1			;avale le return apres le $1B

	rts

;*************** INITIALISATION ***************

Init:

;----- reservation de la memoire copper -----

	move.l #CopSize,d0
	move.l #MEMF_CHIP,d1
	CALLEXEC AllocMem
	move.l d0,Cop_adr

;----- reservation de la memoire plane buffer -----

	move.l #PlaneSize,d0
	move.l #MEMF_CHIP+MEMF_CLEAR,d1
	CALLEXEC AllocMem
	move.l d0,PlaneBuffer_adr

;----- reservation de la memoire bitplane 0 -----

	move.l #PlaneSize+2*(SizeY-Font3DHeight-8)*SizeX/8,d0
	move.l #MEMF_CHIP+MEMF_CLEAR,d1
	CALLEXEC AllocMem
	move.l d0,Plane0_adr

;----- reservation de la memoire bitplane 1 -----

	move.l #PlaneSize+2*(SizeY-Font3DHeight-8)*SizeX/8,d0
	move.l #MEMF_CHIP+MEMF_CLEAR,d1
	CALLEXEC AllocMem
	move.l d0,Plane1_adr

;----- reservation de la memoire bitplane 2 -----

	move.l #PlaneSize,d0
	move.l #MEMF_CHIP+MEMF_CLEAR,d1
	CALLEXEC AllocMem
	move.l d0,Plane2_adr

;----- reservation de la memoire bitplane 3 -----

	move.l #SizeX*240/8,d0
	move.l #MEMF_CHIP+MEMF_CLEAR,d1
	CALLEXEC AllocMem
	move.l d0,Plane3_adr

;----- reservation de la memoire cordoonnees 2D -----

	move.l #CoorSize,d0
	move.l #MEMF_CHIP+MEMF_CLEAR,d1
	CALLEXEC AllocMem
	move.l d0,Coor2D_adr

;----- creation de la copperlist -----

	movea.l Cop_adr,a0

	move.l #$01800000,(a0)+
	move.l #$01820777,(a0)+
	move.l #$01840777,(a0)+
	move.l #$01860BBB,(a0)+
	move.l #$01880777,(a0)+
	move.l #$018A0DDD,(a0)+
	move.l #$018C0BBB,(a0)+
	move.l #$018E0FFF,(a0)+
	move.l #$01900900,(a0)+
	move.l #$01920777,(a0)+
	move.l #$01940777,(a0)+
	move.l #$01960BBB,(a0)+
	move.l #$01980777,(a0)+
	move.l #$019A0DDD,(a0)+
	move.l #$019C0BBB,(a0)+
	move.l #$019E0FFF,(a0)+

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #StartY*256+StartDisplayX,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #StopY*256+StopX,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #NbPlane,d0
	ror.w #4,d0
	bset #9,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #DDF_Strt,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #DDF_Stop,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #ModuloPair,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #ModuloImpair,(a0)+
	move.l #$01060000,(a0)+
	move.l #$01FC0000,(a0)+

	move.l Plane0_adr,d0
	move.w #$E0,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$E2,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l Plane1_adr,d0
	move.w #$E4,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$E6,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l Plane2_adr,d0
	move.w #$E8,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$EA,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l Plane3_adr,d0
	move.w #$EC,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$EE,(a0)+
	swap d0
	move.w d0,(a0)+

	move.w #StartY,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01800444,(a0)+

	move.w #StartY+Font3DHeight+8,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01900FFF,(a0)+
	move.l #$01800FFF,(a0)+

	move.l Plane0_adr,d0
	addi.l #PlaneSize,d0
	move.w #$E0,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$E2,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l Plane1_adr,d0
	addi.l #PlaneSize,d0
	move.w #$E4,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$E6,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l Plane2_adr,d0
	addi.l #(Font3DHeight+8)*SizeX/8,d0
	move.w #$E8,(a0)+
	swap d0
	move.w d0,(a0)+
	move.w #$EA,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l #$01820FFF,(a0)+
	move.l #$01840BBB,(a0)+
	move.l #$01920FFF,(a0)+
	move.l #$01940BBB,(a0)+

	move.w #StartY+Font3DHeight+8+1,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01900008,(a0)+
	move.l #$01800990,(a0)+

	move.w #StartY+SizeY,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01800000,(a0)+

	move.l #$FFFFFFFE,(a0)

;----- forbid -----

	CALLEXEC Forbid

;----- modif DMA,... -----

	lea $DFF000,a5
	move.w DMACONR(a5),DMACON_bak
	move.w INTENAR(a5),INTENA_bak
	move.w #$1FFF,INTENA(a5)	;propacker level 6
	move.w #$7FFF,INTREQ(a5)
	move.w #$7FFF,DMACON(a5)
	move.w #$2E-1,d0
	lea $8,a0
	lea Vectors_bak,a1
	lea Vectors_end,a2
Init_VecLoop:
	move.l (a0),(a1)+
	move.l a2,(a0)+
	dbf d0,Init_VecLoop
	move.l Cop_adr,COP1LCH(a5)
	clr.w COPJMP1(a5)
	move.w #$87C0,DMACON(a5)	;COPEN, BPLEN, BLTPRI, DMAEN

	rts

;*************** PROPACKER ROUTINE ***************

*****************************************
* Pro-Packer v2.1 Replay-Routine.	*
* Based upon the PT1.1B-Replayer	*
* by Lars 'ZAP' Hamre/Amiga Freelancers.*
* Modified by Estrup/Static Bytes.	*
*****************************************

; A LITTLE BUG HAS BEEN FOUND AND FIXED IN THE OFFICIAL ONE.
; Revolution / ANALOG.


mt_lev6use=		1		; 0=NO, 1=YES
mt_finetuneused=	0		; 0=NO, 1=YES

mt_init	LEA	mt_data,A0
	MOVE.L	A0,mt_SongDataPtr
	LEA	250(A0),A1
	MOVE.W	#511,D0
	MOVEQ	#0,D1
mtloop	MOVE.L	D1,D2
	SUBQ.W	#1,D0
mtloop2	MOVE.B	(A1)+,D1
	CMP.W	D2,D1
	BGT.S	mtloop
	DBRA	D0,mtloop2
	ADDQ	#1,D2

	MOVE.W	D2,D3
	MULU	#128,D3
	ADD.L	#766,D3
	ADD.L	mt_SongDataPtr(PC),D3
	MOVE.L	D3,mt_LWTPtr

	LEA	mt_SampleStarts(PC),A1
	MULU	#128,D2
	ADD.L	#762,D2
	ADD.L	(A0,D2.L),D2
	ADD.L	mt_SongDataPtr(PC),D2
	ADDQ.L	#4,D2
	MOVE.L	D2,A2
	MOVEQ	#30,D0
mtloop3	MOVE.L	A2,(A1)+
	MOVEQ	#0,D1
	MOVE.W	(A0),D1
	ADD.L	D1,D1
	ADD.L	D1,A2
	LEA	8(A0),A0
	DBRA	D0,mtloop3

	OR.B	#2,$BFE001
	lea	mt_speed(PC),A4
	MOVE.B	#6,(A4)
	CLR.B	mt_counter-mt_speed(A4)
	CLR.B	mt_SongPos-mt_speed(A4)
	CLR.W	mt_PatternPos-mt_speed(A4)
mt_end	LEA	$DFF096,A0
	CLR.W	$12(A0)
	CLR.W	$22(A0)
	CLR.W	$32(A0)
	CLR.W	$42(A0)
	MOVE.W	#$F,(A0)
	RTS

mt_music
	MOVEM.L	D0-D4/D7/A0-A6,-(SP)
	LEA	0.w,A4
	ADDQ.B	#1,mt_counter
	MOVE.B	mt_counter(PC),D0
	CMP.B	mt_speed(PC),D0
	BLO.S	mt_NoNewNote
	CLR.B	mt_counter
	TST.B	mt_PattDelTime2
	BEQ.S	mt_GetNewNote
	BSR.S	mt_NoNewAllChannels
	BRA.W	mt_dskip

mt_NoNewNote
	BSR.S	mt_NoNewAllChannels
	BRA.W	mt_NoNewPosYet

mt_NoNewAllChannels
	LEA	$DFF090,A5
	LEA	mt_chan1temp-44(PC),A6
	BSR.W	mt_CheckEfx
	BSR.W	mt_CheckEfx
	BSR.W	mt_CheckEfx
	BRA.W	mt_CheckEfx

mt_GetNewNote
	MOVE.L	mt_SongDataPtr(PC),A0
	LEA	(A0),A3
	LEA	122(A0),A2	;pattpo
	LEA	762(A0),A0	;patterndata
	CLR.W	mt_DMACONtemp

	LEA	$DFF090,A5
	LEA	mt_chan1temp-44(PC),A6
	BSR.S	mt_DoVoice
	BSR.S	mt_DoVoice
	BSR.B	mt_DoVoice
	BSR.B	mt_DoVoice
	BRA.W	mt_SetDMA

mt_DoVoice
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.B	mt_SongPos(PC),D0
	LEA	128(A2),A2
	MOVE.B	(A2,D0.W),D1
	MOVE.W	mt_PatternPos(PC),D2
	LSL	#7,D1
	LSR.W	#1,D2
	ADD.W	D2,D1
	LEA	$10(A5),A5
	LEA	44(A6),A6

	TST.L	(A6)
	BNE.S	mt_plvskip
	BSR.W	mt_PerNop
mt_plvskip
	MOVE.W	(A0,D1.W),D1
	LSL.W	#2,D1
	MOVE.L	A0,-(sp)
	MOVE.L	mt_LWTPtr(PC),A0
	MOVE.L	(A0,D1.W),(A6)
	MOVE.L	(sp)+,A0
	MOVE.B	2(A6),D2
	AND.L	#$F0,D2
	LSR.B	#4,D2
	MOVE.B	(A6),D0
	AND.B	#$F0,D0
	OR.B	D0,D2
	BEQ.B	mt_SetRegs
	MOVEQ	#0,D3
	LEA	mt_SampleStarts(PC),A1
	SUBQ	#1,D2
	MOVE	D2,D4
	ADD	D2,D2
	ADD	D2,D2
	LSL	#3,D4
	MOVE.L	(A1,D2.L),4(A6)
	MOVE.W	(A3,D4.W),8(A6)
	MOVE.W	(A3,D4.W),40(A6)
	MOVE.W	2(A3,D4.W),18(A6)
	MOVE.L	4(A6),D2	; Get start
	MOVE.W	4(A3,D4.W),D3	; Get repeat
	BEQ.S	mt_NoLoop
	MOVE.W	D3,D0		; Get repeat
	ADD.W	D3,D3
	ADD.L	D3,D2		; Add repeat
	ADD.W	6(A3,D4.W),D0	; Add replen
	MOVE.W	D0,8(A6)

mt_NoLoop
	MOVE.L	D2,10(A6)
	MOVE.L	D2,36(A6)
	MOVE.W	6(A3,D4.W),14(A6)	; Save replen
	MOVE.B	19(A6),9(A5)	; Set volume
mt_SetRegs
	MOVE.W	(A6),D0
	AND.W	#$0FFF,D0
	BEQ.W	mt_CheckMoreEfx	; If no note

	IF mt_finetuneused=1
	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0E50,D0
	BEQ.S	mt_DoSetFineTune
	ENDC

	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	CMP.B	#3,D0	; TonePortamento
	BEQ.S	mt_ChkTonePorta
	CMP.B	#5,D0
	BEQ.S	mt_ChkTonePorta
	CMP.B	#9,D0	; Sample Offset
	BNE.S	mt_SetPeriod
	BSR.W	mt_CheckMoreEfx
	BRA.S	mt_SetPeriod

mt_ChkTonePorta
	BSR.W	mt_SetTonePorta
	BRA.W	mt_CheckMoreEfx

mt_DoSetFineTune
	BSR.W	mt_SetFineTune

mt_SetPeriod
	MOVEM.L	D1/A1,-(SP)
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1

	IF mt_finetuneused=0
	MOVE.W	D1,16(A6)

	ELSE
mt_SetPeriod2
	LEA	mt_PeriodTable(PC),A1
	MOVEQ	#36,D7
mt_ftuloop
	CMP.W	(A1)+,D1
	BHS.S	mt_ftufound
	DBRA	D7,mt_ftuloop
mt_ftufound
	MOVEQ	#0,D1
	MOVE.B	18(A6),D1
	LSL	#3,D1
	MOVE	D1,D0
	LSL	#3,D1
	ADD	D0,D1
	MOVE.W	-2(A1,D1.W),16(A6)
	ENDC

	MOVEM.L	(SP)+,D1/A1

	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0ED0,D0 ; Notedelay
	BEQ.W	mt_CheckMoreEfx

	MOVE.W	20(A6),$DFF096
	BTST	#2,30(A6)
	BNE.S	mt_vibnoc
	CLR.B	27(A6)
mt_vibnoc
	BTST	#6,30(A6)
	BNE.S	mt_trenoc
	CLR.B	29(A6)
mt_trenoc
	MOVE.L	4(A6),(A5)	; Set start
	MOVE.W	8(A6),4(A5)	; Set length
	MOVE.W	16(A6),6(A5)	; Set period
	MOVE.W	20(A6),D0
	OR.W	D0,mt_DMACONtemp
	BRA.W	mt_CheckMoreEfx
 
mt_SetDMA
	IF mt_lev6use=1
	lea	$bfd000,a3
	move.b	#$7f,$d00(a3)
	move.w	#$2000,$dff09c
	move.w	#$a000,$dff09a
	move.l	$78.w,mt_oldirq
	move.l	#mt_irq1,$78.w
	moveq	#0,d0
	move.b	d0,$e00(a3)
	move.b	#$a8,$400(a3)
	move.b	d0,$500(a3)
	move.b	#$11,$e00(a3)
	move.b	#$81,$d00(a3)
	OR.W	#$8000,mt_DMACONtemp
	BRA.W	mt_dskip

	ELSE
	OR.W	#$8000,mt_DMACONtemp
	bsr.w	mt_WaitDMA
	ENDC

	IF mt_lev6use=1
mt_irq1:tst.b	$bfdd00
	MOVE.W	mt_dmacontemp(pc),$DFF096
	move.w	#$2000,$dff09c
	move.l	#mt_irq2,$78.w
	rte

	ELSE
	MOVE.W	mt_dmacontemp(pc),$DFF096
	bsr.w	mt_WaitDMA
	ENDC

	IF mt_lev6use=1
mt_irq2:tst.b	$bfdd00
	movem.l	a5-a6,-(a7)
	ENDC

	LEA	$DFF0A0,A5
	LEA	mt_chan1temp(PC),A6
	MOVE.L	10(A6),(A5)
	MOVE.W	14(A6),4(A5)
	MOVE.L	54(A6),$10(A5)
	MOVE.W	58(A6),$14(A5)
	MOVE.L	98(A6),$20(A5)
	MOVE.W	102(A6),$24(A5)
	MOVE.L	142(A6),$30(A5)
	MOVE.W	146(A6),$34(A5)

	IF mt_lev6use=1
	move.b	#0,$bfde00
	move.b	#$7f,$bfdd00
	move.l	mt_oldirq(pc),$78.w
	move.w	#$2000,$dff09c
	movem.l	(a7)+,a5-a6
	rte
	ENDC

mt_dskip
	lea	mt_speed(PC),A4
	ADDQ.W	#4,mt_PatternPos-mt_speed(A4)
	MOVE.B	mt_PattDelTime-mt_speed(A4),D0
	BEQ.S	mt_dskc
	MOVE.B	D0,mt_PattDelTime2-mt_speed(A4)
	CLR.B	mt_PattDelTime-mt_speed(A4)
mt_dskc	TST.B	mt_PattDelTime2-mt_speed(A4)
	BEQ.S	mt_dska
	SUBQ.B	#1,mt_PattDelTime2-mt_speed(A4)
	BEQ.S	mt_dska
	SUBQ.W	#4,mt_PatternPos-mt_speed(A4)
mt_dska	TST.B	mt_PBreakFlag-mt_speed(A4)
	BEQ.S	mt_nnpysk
	SF	mt_PBreakFlag-mt_speed(A4)
	MOVEQ	#0,D0
	MOVE.B	mt_PBreakPos(PC),D0
	CLR.B	mt_PBreakPos-mt_speed(A4)
	LSL	#2,D0
	MOVE.W	D0,mt_PatternPos-mt_speed(A4)
mt_nnpysk
	CMP.W	#256,mt_PatternPos-mt_speed(A4)
	BLO.S	mt_NoNewPosYet
mt_NextPosition	
	MOVEQ	#0,D0
	MOVE.B	mt_PBreakPos(PC),D0
	LSL	#2,D0
	MOVE.W	D0,mt_PatternPos-mt_speed(A4)
	CLR.B	mt_PBreakPos-mt_speed(A4)
	CLR.B	mt_PosJumpFlag-mt_speed(A4)
	ADDQ.B	#1,mt_SongPos-mt_speed(A4)
	AND.B	#$7F,mt_SongPos-mt_speed(A4)
	MOVE.B	mt_SongPos(PC),D1
	MOVE.L	mt_SongDataPtr(PC),A0
	CMP.B	248(A0),D1
	BLO.S	mt_NoNewPosYet
	CLR.B	mt_SongPos-mt_speed(A4)
mt_NoNewPosYet	
	TST.B	mt_PosJumpFlag-mt_speed(A4)
	BNE.S	mt_NextPosition
	MOVEM.L	(SP)+,D0-D4/D7/A0-A6
	RTS

mt_CheckEfx
	LEA	$10(A5),A5
	LEA	44(A6),A6
	BSR.W	mt_UpdateFunk
	MOVE.W	2(A6),D0
	AND.W	#$0FFF,D0
	BEQ.S	mt_PerNop
	MOVE.B	2(A6),D0
	MOVEQ	#$0F,D1
	AND.L	D1,D0
	BEQ.S	mt_Arpeggio
	SUBQ	#1,D0
	BEQ.W	mt_PortaUp
	SUBQ	#1,D0
	BEQ.W	mt_PortaDown
	SUBQ	#1,D0
	BEQ.W	mt_TonePortamento
	SUBQ	#1,D0
	BEQ.W	mt_Vibrato
	SUBQ	#1,D0
	BEQ.W	mt_TonePlusVolSlide
	SUBQ	#1,D0
	BEQ.W	mt_VibratoPlusVolSlide
	SUBQ	#8,D0
	BEQ.W	mt_E_Commands
SetBack	MOVE.W	16(A6),6(A5)
	ADDQ	#7,D0
	BEQ.W	mt_Tremolo
	SUBQ	#3,D0
	BEQ.W	mt_VolumeSlide
mt_Return2
	RTS

mt_PerNop
	MOVE.W	16(A6),6(A5)
	RTS

mt_Arpeggio
	MOVEQ	#0,D0
	MOVE.B	mt_counter(PC),D0
	DIVS	#3,D0
	SWAP	D0
	TST.W	D0
	BEQ.S	mt_Arpeggio2
	SUBQ	#2,D0
	BEQ.S	mt_Arpeggio1
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	LSR.B	#4,D0
	BRA.S	mt_Arpeggio3

mt_Arpeggio2
	MOVE.W	16(A6),6(A5)
	RTS

mt_Arpeggio1
	MOVE.B	3(A6),D0
	AND.W	#15,D0
mt_Arpeggio3
	ADD.W	D0,D0
	LEA	mt_PeriodTable(PC),A0

	IF mt_finetuneused=1
	MOVEQ	#0,D1
	MOVE.B	18(A6),D1
	LSL	#3,D1
	MOVE	D1,D2
	LSL	#3,D1
	ADD	D2,D1
	ADD.L	D1,A0
	ENDC

	MOVE.W	16(A6),D1
	MOVEQ	#36,D7
mt_arploop
	CMP.W	(A0)+,D1
	BHS.S	mt_Arpeggio4
	DBRA	D7,mt_arploop
	RTS

mt_Arpeggio4
	MOVE.W	-2(A0,D0.W),6(A5)
	RTS

mt_FinePortaUp
	TST.B	mt_counter
	BNE.S	mt_Return2
	MOVE.B	#$0F,mt_LowMask
mt_PortaUp
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	AND.B	mt_LowMask(PC),D0
	MOVE.B	#$FF,mt_LowMask
	SUB.W	D0,16(A6)
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#113,D0
	BPL.S	mt_PortaUskip
	AND.W	#$F000,16(A6)
	OR.W	#113,16(A6)
mt_PortaUskip
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)
	RTS	
 
mt_FinePortaDown
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	#$0F,mt_LowMask
mt_PortaDown
	CLR.W	D0
	MOVE.B	3(A6),D0
	AND.B	mt_LowMask(PC),D0
	MOVE.B	#$FF,mt_LowMask
	ADD.W	D0,16(A6)
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#856,D0
	BMI.S	mt_PortaDskip
	AND.W	#$F000,16(A6)
	OR.W	#856,16(A6)
mt_PortaDskip
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)
	RTS

mt_SetTonePorta
	MOVEM.L	A0,-(SP)
	MOVE.W	(A6),D2
	AND.W	#$0FFF,D2
	LEA	mt_PeriodTable(PC),A0

	IF	mt_finetuneused=1
	MOVEQ	#0,D0
	MOVE.B	18(A6),D0
	ADD	D0,D0
	MOVE	D0,D7
	ADD	D0,D0
	ADD	D0,D0
	ADD	D0,D7
	LSL	#3,D0
	ADD	D7,D0
	ADD.L	D0,A0
	ENDC

	MOVEQ	#0,D0
mt_StpLoop
	CMP.W	(A0,D0.W),D2
	BHS.S	mt_StpFound
	ADDQ	#2,D0
	CMP.W	#37*2,D0
	BLO.S	mt_StpLoop
	MOVEQ	#35*2,D0
mt_StpFound
	BTST	#3,18(A6)
	BEQ.S	mt_StpGoss
	TST.W	D0
	BEQ.S	mt_StpGoss
	SUBQ	#2,D0
mt_StpGoss
	MOVE.W	(A0,D0.W),D2
	MOVE.L	(SP)+,A0
	MOVE.W	D2,24(A6)
	MOVE.W	16(A6),D0
	CLR.B	22(A6)
	CMP.W	D0,D2
	BEQ.S	mt_ClearTonePorta
	BGE.W	mt_Return2
	MOVE.B	#1,22(A6)
	RTS

mt_ClearTonePorta
	CLR.W	24(A6)
	RTS

mt_TonePortamento
	MOVE.B	3(A6),D0
	BEQ.S	mt_TonePortNoChange
	MOVE.B	D0,23(A6)
	CLR.B	3(A6)
mt_TonePortNoChange
	TST.W	24(A6)
	BEQ.W	mt_Return2
	MOVEQ	#0,D0
	MOVE.B	23(A6),D0
	TST.B	22(A6)
	BNE.S	mt_TonePortaUp
mt_TonePortaDown
	ADD.W	D0,16(A6)
	MOVE.W	24(A6),D0
	CMP.W	16(A6),D0
	BGT.S	mt_TonePortaSetPer
	MOVE.W	24(A6),16(A6)
	CLR.W	24(A6)
	BRA.S	mt_TonePortaSetPer

mt_TonePortaUp
	SUB.W	D0,16(A6)
	MOVE.W	24(A6),D0
	CMP.W	16(A6),D0
	BLT.S	mt_TonePortaSetPer
	MOVE.W	24(A6),16(A6)
	CLR.W	24(A6)

mt_TonePortaSetPer
	MOVE.W	16(A6),D2
	MOVE.B	31(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_GlissSkip
	LEA	mt_PeriodTable(PC),A0

	IF mt_finetuneused=1
	MOVEQ	#0,D0
	MOVE.B	18(A6),D0
	LSL	#3,D0
	MOVE	D0,D1
	LSL	#3,D0
	ADD	D1,D0
	ADD.L	D0,A0
	ENDC

	MOVEQ	#0,D0
mt_GlissLoop
	CMP.W	(A0,D0.W),D2
	BHS.S	mt_GlissFound
	ADDQ	#2,D0
	CMP.W	#36*2,D0
	BLO.S	mt_GlissLoop
	MOVEQ	#35*2,D0
mt_GlissFound
	MOVE.W	(A0,D0.W),D2
mt_GlissSkip
	MOVE.W	D2,6(A5) ; Set period
	RTS

mt_Vibrato
	MOVE.B	3(A6),D0
	BEQ.S	mt_Vibrato2
	MOVE.B	26(A6),D2
	AND.B	#$0F,D0
	BEQ.S	mt_vibskip
	AND.B	#$F0,D2
	OR.B	D0,D2
mt_vibskip
	MOVE.B	3(A6),D0
	AND.B	#$F0,D0
	BEQ.S	mt_vibskip2
	AND.B	#$0F,D2
	OR.B	D0,D2
mt_vibskip2
	MOVE.B	D2,26(A6)
mt_Vibrato2
	MOVE.B	27(A6),D0
	LEA	mt_VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVE.B	30(A6),D2
	AND.W	#$03,D2
	BEQ.S	mt_vib_sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.S	mt_vib_rampdown
	MOVE.B	#255,D2
	BRA.S	mt_vib_set
mt_vib_rampdown
	TST.B	27(A6)
	BPL.S	mt_vib_rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.S	mt_vib_set
mt_vib_rampdown2
	MOVE.B	D0,D2
	BRA.S	mt_vib_set
mt_vib_sine
	MOVE.B	0(A4,D0.W),D2
mt_vib_set
	MOVE.B	26(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#7,D2
	MOVE.W	16(A6),D0
	TST.B	27(A6)
	BMI.S	mt_VibratoNeg
	ADD.W	D2,D0
	BRA.S	mt_Vibrato3
mt_VibratoNeg
	SUB.W	D2,D0
mt_Vibrato3
	MOVE.W	D0,6(A5)
	MOVE.B	26(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,27(A6)
	RTS

mt_TonePlusVolSlide
	BSR.W	mt_TonePortNoChange
	BRA.W	mt_VolumeSlide

mt_VibratoPlusVolSlide
	BSR.S	mt_Vibrato2
	BRA.W	mt_VolumeSlide

mt_Tremolo
	MOVE.B	3(A6),D0
	BEQ.S	mt_Tremolo2
	MOVE.B	28(A6),D2
	AND.B	#$0F,D0
	BEQ.S	mt_treskip
	AND.B	#$F0,D2
	OR.B	D0,D2
mt_treskip
	MOVE.B	3(A6),D0
	AND.B	#$F0,D0
	BEQ.S	mt_treskip2
	AND.B	#$0F,D2
	OR.B	D0,D2
mt_treskip2
	MOVE.B	D2,28(A6)
mt_Tremolo2
	MOVE.B	29(A6),D0
	LEA	mt_VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVEQ	#0,D2
	MOVE.B	30(A6),D2
	LSR.B	#4,D2
	AND.B	#$03,D2
	BEQ.S	mt_tre_sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.S	mt_tre_rampdown
	MOVE.B	#255,D2
	BRA.S	mt_tre_set
mt_tre_rampdown
	TST.B	27(A6)
	BPL.S	mt_tre_rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.S	mt_tre_set
mt_tre_rampdown2
	MOVE.B	D0,D2
	BRA.S	mt_tre_set
mt_tre_sine
	MOVE.B	0(A4,D0.W),D2
mt_tre_set
	MOVE.B	28(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#6,D2
	MOVEQ	#0,D0
	MOVE.B	19(A6),D0
	TST.B	29(A6)
	BMI.S	mt_TremoloNeg
	ADD.W	D2,D0
	BRA.S	mt_Tremolo3
mt_TremoloNeg
	SUB.W	D2,D0
mt_Tremolo3
	BPL.S	mt_TremoloSkip
	CLR.W	D0
mt_TremoloSkip
	CMP.W	#$40,D0
	BLS.S	mt_TremoloOk
	MOVE.W	#$40,D0
mt_TremoloOk
	MOVE.W	D0,8(A5)
	MOVE.B	28(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,29(A6)
	RTS

mt_SampleOffset
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	BEQ.S	mt_sononew
	MOVE.B	D0,32(A6)
mt_sononew
	MOVE.B	32(A6),D0
	LSL.W	#7,D0
	CMP.W	8(A6),D0
	BGE.S	mt_sofskip
	SUB.W	D0,8(A6)
	ADD.W	D0,D0
	ADD.L	D0,4(A6)
	RTS
mt_sofskip
	MOVE.W	#$0001,8(A6)
	RTS

mt_VolumeSlide
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	LSR.B	#4,D0
	TST.B	D0
	BEQ.S	mt_VolSlideDown
mt_VolSlideUp
	ADD.B	D0,19(A6)
	CMP.B	#$40,19(A6)
	BMI.S	mt_vsuskip
	MOVE.B	#$40,19(A6)
mt_vsuskip
	MOVE.B	19(A6),9(A5)
	RTS

mt_VolSlideDown
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
mt_VolSlideDown2
	SUB.B	D0,19(A6)
	BPL.S	mt_vsdskip
	CLR.B	19(A6)
mt_vsdskip
	MOVE.B	19(A6),9(A5)
	RTS

mt_PositionJump
	MOVE.B	3(A6),D0
	SUBQ	#1,D0
	MOVE.B	D0,mt_SongPos
mt_pj2	CLR.B	mt_PBreakPos
	ST 	mt_PosJumpFlag
	RTS

mt_VolumeChange
	MOVE.B	3(A6),D0
	CMP.B	#$40,D0
	BLS.S	mt_VolumeOk
	MOVEQ	#$40,D0
mt_VolumeOk
	MOVE.B	D0,19(A6)
	MOVE.B	D0,9(A5)
	RTS

mt_PatternBreak
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	MOVE.W	D0,D2
	LSR.B	#4,D0
	ADD	D0,D0
	MOVE	D0,D1
	ADD	D0,D0
	ADD	D0,D0
	ADD	D1,D0
	AND.B	#$0F,D2
	ADD.B	D2,D0
	CMP.B	#63,D0
	BHI.S	mt_pj2
	MOVE.B	D0,mt_PBreakPos
	ST	mt_PosJumpFlag
	RTS

mt_SetSpeed
	MOVE.B	3(A6),D0
	BEQ.W	mt_Return2
	CLR.B	mt_counter
	MOVE.B	D0,mt_speed
	RTS

mt_CheckMoreEfx
	BSR.W	mt_UpdateFunk
	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	SUB.B	#9,D0
	BEQ.W	mt_SampleOffset
	SUBQ	#2,D0
	BEQ.W	mt_PositionJump
	SUBQ	#1,D0
	BEQ.B	mt_VolumeChange
	SUBQ	#1,D0
	BEQ.S	mt_PatternBreak
	SUBQ	#1,D0
	BEQ.S	mt_E_Commands
	SUBQ	#1,D0
	BEQ.S	mt_SetSpeed
	BRA.W	mt_PerNop

mt_E_Commands
	MOVE.B	3(A6),D0
	AND.W	#$F0,D0
	LSR.B	#4,D0
	BEQ.S	mt_FilterOnOff
	SUBQ	#1,D0
	BEQ.W	mt_FinePortaUp
	SUBQ	#1,D0
	BEQ.W	mt_FinePortaDown
	SUBQ	#1,D0
	BEQ.S	mt_SetGlissControl
	SUBQ	#1,D0
	BEQ.B	mt_SetVibratoControl

	IF mt_finetuneused=1
	SUBQ	#1,D0
	BEQ.B	mt_SetFineTune
	SUBQ	#1,D0

	ELSE
	SUBQ	#2,D0
	ENDC

	BEQ.B	mt_JumpLoop
	SUBQ	#1,D0
	BEQ.W	mt_SetTremoloControl
	SUBQ	#2,D0
	BEQ.W	mt_RetrigNote
	SUBQ	#1,D0
	BEQ.W	mt_VolumeFineUp
	SUBQ	#1,D0
	BEQ.W	mt_VolumeFineDown
	SUBQ	#1,D0
	BEQ.W	mt_NoteCut
	SUBQ	#1,D0
	BEQ.W	mt_NoteDelay
	SUBQ	#1,D0
	BEQ.W	mt_PatternDelay
	BRA.W	mt_FunkIt

mt_FilterOnOff
	MOVE.B	3(A6),D0
	AND.B	#1,D0
	ADD.B	D0,D0
	AND.B	#$FD,$BFE001
	OR.B	D0,$BFE001
	RTS	

mt_SetGlissControl
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,31(A6)
	OR.B	D0,31(A6)
	RTS

mt_SetVibratoControl
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,30(A6)
	OR.B	D0,30(A6)
	RTS

mt_SetFineTune
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	MOVE.B	D0,18(A6)
	RTS

mt_JumpLoop
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_SetLoop
	TST.B	34(A6)
	BEQ.S	mt_jumpcnt
	SUBQ.B	#1,34(A6)
	BEQ.W	mt_Return2
mt_jmploop 	MOVE.B	33(A6),mt_PBreakPos
	ST	mt_PBreakFlag
	RTS

mt_jumpcnt
	MOVE.B	D0,34(A6)
	BRA.S	mt_jmploop

mt_SetLoop
	MOVE.W	mt_PatternPos(PC),D0
	LSR	#2,D0
	MOVE.B	D0,33(A6)
	RTS

mt_SetTremoloControl
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,30(A6)
	OR.B	D0,30(A6)
	RTS

mt_RetrigNote
	MOVE.L	D1,-(SP)
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	BEQ.S	mt_rtnend
	MOVEQ	#0,d1
	MOVE.B	mt_counter(PC),D1
	BNE.S	mt_rtnskp
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1
	BNE.S	mt_rtnend
	MOVEQ	#0,D1
	MOVE.B	mt_counter(PC),D1
mt_rtnskp
	DIVU	D0,D1
	SWAP	D1
	TST.W	D1
	BNE.S	mt_rtnend
mt_DoRetrig
	MOVE.W	20(A6),$DFF096	; Channel DMA off
	MOVE.L	4(A6),(A5)	; Set sampledata pointer
	MOVE.W	8(A6),4(A5)	; Set length
	BSR.W	mt_WaitDMA
	MOVE.W	20(A6),D0
	BSET	#15,D0
	MOVE.W	D0,$DFF096
	BSR.W	mt_WaitDMA
	MOVE.L	10(A6),(A5)
	MOVE.L	14(A6),4(A5)
mt_rtnend
	MOVE.L	(SP)+,D1
	RTS

mt_VolumeFineUp
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.W	#$F,D0
	BRA.W	mt_VolSlideUp

mt_VolumeFineDown
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	BRA.W	mt_VolSlideDown2

mt_NoteCut
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	CMP.B	mt_counter(PC),D0
	BNE.W	mt_Return2
	CLR.B	19(A6)
	CLR.W	8(A5)
	RTS

mt_NoteDelay
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	CMP.B	mt_Counter(PC),D0
	BNE.W	mt_Return2
	MOVE.W	(A6),D0
	BEQ.W	mt_Return2
	MOVE.L	D1,-(SP)
	BRA.W	mt_DoRetrig

mt_PatternDelay
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	TST.B	mt_PattDelTime2
	BNE.W	mt_Return2
	ADDQ.B	#1,D0
	MOVE.B	D0,mt_PattDelTime
	RTS

mt_FunkIt
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,31(A6)
	OR.B	D0,31(A6)
	TST.B	D0
	BEQ.W	mt_Return2
mt_UpdateFunk
	MOVEM.L	D1/A0,-(SP)
	MOVEQ	#0,D0
	MOVE.B	31(A6),D0
	LSR.B	#4,D0
	BEQ.S	mt_funkend
	LEA	mt_FunkTable(PC),A0
	MOVE.B	(A0,D0.W),D0
	ADD.B	D0,35(A6)
	BTST	#7,35(A6)
	BEQ.S	mt_funkend
	CLR.B	35(A6)

	MOVE.L	10(A6),D0
	MOVEQ	#0,D1
	MOVE.W	14(A6),D1
	ADD.L	D1,D0
	ADD.L	D1,D0
	MOVE.L	36(A6),A0
	ADDQ.L	#1,A0
	CMP.L	D0,A0
	BLO.S	mt_funkok
	MOVE.L	10(A6),A0
mt_funkok
	MOVE.L	A0,36(A6)
	NEG.B	(A0)
	SUBQ.B	#1,(A0)
mt_funkend
	MOVEM.L	(SP)+,D1/A0
	RTS

mt_WaitDMA
	MOVEQ	#3,D0
mt_WaitDMA2
	MOVE.B	$DFF006,D1
mt_WaitDMA3
	CMP.B	$DFF006,D1
	BEQ.S	mt_WaitDMA3
	DBF	D0,mt_WaitDMA2
	RTS

mt_FunkTable dc.b 0,5,6,7,8,10,11,13,16,19,22,26,32,43,64,128

mt_VibratoTable	
	dc.b   0, 24, 49, 74, 97,120,141,161
	dc.b 180,197,212,224,235,244,250,253
	dc.b 255,253,250,244,235,224,212,197
	dc.b 180,161,141,120, 97, 74, 49, 24

mt_PeriodTable
; Tuning 0, Normal
	dc.w	856,808,762,720,678,640,604,570,538,508,480,453
	dc.w	428,404,381,360,339,320,302,285,269,254,240,226
	dc.w	214,202,190,180,170,160,151,143,135,127,120,113
; Tuning 1
	dc.w	850,802,757,715,674,637,601,567,535,505,477,450
	dc.w	425,401,379,357,337,318,300,284,268,253,239,225
	dc.w	213,201,189,179,169,159,150,142,134,126,119,113
; Tuning 2
	dc.w	844,796,752,709,670,632,597,563,532,502,474,447
	dc.w	422,398,376,355,335,316,298,282,266,251,237,224
	dc.w	211,199,188,177,167,158,149,141,133,125,118,112
; Tuning 3
	dc.w	838,791,746,704,665,628,592,559,528,498,470,444
	dc.w	419,395,373,352,332,314,296,280,264,249,235,222
	dc.w	209,198,187,176,166,157,148,140,132,125,118,111
; Tuning 4
	dc.w	832,785,741,699,660,623,588,555,524,495,467,441
	dc.w	416,392,370,350,330,312,294,278,262,247,233,220
	dc.w	208,196,185,175,165,156,147,139,131,124,117,110
; Tuning 5
	dc.w	826,779,736,694,655,619,584,551,520,491,463,437
	dc.w	413,390,368,347,328,309,292,276,260,245,232,219
	dc.w	206,195,184,174,164,155,146,138,130,123,116,109
; Tuning 6
	dc.w	820,774,730,689,651,614,580,547,516,487,460,434
	dc.w	410,387,365,345,325,307,290,274,258,244,230,217
	dc.w	205,193,183,172,163,154,145,137,129,122,115,109
; Tuning 7
	dc.w	814,768,725,684,646,610,575,543,513,484,457,431
	dc.w	407,384,363,342,323,305,288,272,256,242,228,216
	dc.w	204,192,181,171,161,152,144,136,128,121,114,108
; Tuning -8
	dc.w	907,856,808,762,720,678,640,604,570,538,508,480
	dc.w	453,428,404,381,360,339,320,302,285,269,254,240
	dc.w	226,214,202,190,180,170,160,151,143,135,127,120
; Tuning -7
	dc.w	900,850,802,757,715,675,636,601,567,535,505,477
	dc.w	450,425,401,379,357,337,318,300,284,268,253,238
	dc.w	225,212,200,189,179,169,159,150,142,134,126,119
; Tuning -6
	dc.w	894,844,796,752,709,670,632,597,563,532,502,474
	dc.w	447,422,398,376,355,335,316,298,282,266,251,237
	dc.w	223,211,199,188,177,167,158,149,141,133,125,118
; Tuning -5
	dc.w	887,838,791,746,704,665,628,592,559,528,498,470
	dc.w	444,419,395,373,352,332,314,296,280,264,249,235
	dc.w	222,209,198,187,176,166,157,148,140,132,125,118
; Tuning -4
	dc.w	881,832,785,741,699,660,623,588,555,524,494,467
	dc.w	441,416,392,370,350,330,312,294,278,262,247,233
	dc.w	220,208,196,185,175,165,156,147,139,131,123,117
; Tuning -3
	dc.w	875,826,779,736,694,655,619,584,551,520,491,463
	dc.w	437,413,390,368,347,328,309,292,276,260,245,232
	dc.w	219,206,195,184,174,164,155,146,138,130,123,116
; Tuning -2
	dc.w	868,820,774,730,689,651,614,580,547,516,487,460
	dc.w	434,410,387,365,345,325,307,290,274,258,244,230
	dc.w	217,205,193,183,172,163,154,145,137,129,122,115
; Tuning -1
	dc.w	862,814,768,725,684,646,610,575,543,513,484,457
	dc.w	431,407,384,363,342,323,305,288,272,256,242,228
	dc.w	216,203,192,181,171,161,152,144,136,128,121,114

mt_chan1temp	blk.l	5
		dc.w	1
		blk.w	21
		dc.w	2
		blk.w	21
		dc.w	4
		blk.w	21
		dc.w	8
		blk.w	11

mt_SampleStarts	blk.l	31,0

mt_SongDataPtr	dc.l 0
mt_LWTPtr	dc.l 0
mt_oldirq	dc.l 0

mt_speed	dc.b 6
mt_counter	dc.b 0
mt_SongPos	dc.b 0
mt_PBreakPos	dc.b 0
mt_PosJumpFlag	dc.b 0
mt_PBreakFlag	dc.b 0
mt_LowMask	dc.b 0
mt_PattDelTime	dc.b 0
mt_PattDelTime2	dc.b 0,0
mt_PatternPos	dc.w 0
mt_DMACONtemp	dc.w 0
mt_data:	incbin	"sources:interpol3d/mod.blitz-packed"

;*************** FIN DE PROGRAMME ***************


End:	
	WAITBLIT

;----- restauration des canaux DMA, ... ----

	move.w #$2E-1,d0
	lea Vectors_bak,a0
	lea $8,a1
End_VecLoop:
	move.l (a0)+,(a1)+
	dbf d0,End_VecLoop
	move.w DMACON_bak,d0
	bset #15,d0
	move.w d0,DMACON(a5)
	move.w INTENA_bak,d0
	bset #15,d0
	move.w d0,INTENA(a5)

;----- permit -----

	CALLEXEC Permit

;----- liberation de la memoire bitplane 0 -----

	move.l Plane0_adr,a1
	move.l #PlaneSize+2*(SizeY-Font3DHeight-8)*SizeX/8,d0
	CALLEXEC FreeMem

;----- liberation de la memoire bitplane 1 -----

	move.l Plane1_adr,a1
	move.l #PlaneSize+2*(SizeY-Font3DHeight-8)*SizeX/8,d0
	CALLEXEC FreeMem

;----- liberation de la memoire bitplane 2 -----

	move.l Plane2_adr,a1
	move.l #PlaneSize,d0
	CALLEXEC FreeMem

;----- liberation de la memoire bitplane 3 -----

	move.l Plane3_adr,a1
	move.l #SizeX*240/8,d0
	CALLEXEC FreeMem 

;----- liberation de la memoire plane buffer -----
	
	move.l PlaneBuffer_adr,a1
	move.l #PlaneSize,d0
	CALLEXEC FreeMem

;----- liberation de la memoire copper -----

	move.l Cop_adr,a1
	move.l #CopSize,d0
	CALLEXEC FreeMem

;----- liberation de la memoire coordonnees 2D -----

	move.l Coor2D_adr,a1
	move.l #CoorSize,d0
	CALLEXEC FreeMem

;----- restaurer la copperlist dos -----

	lea GFX_name,a1
	CALLEXEC OldOpenLibrary
	move.l d0,a1
	move.l 38(a1),COP1LCH(a5)
	clr.w COPJMP1(a5)
	CALLEXEC CloseLibrary

	rts

;*************** VARIABLES ***************

Vectors_end:	rte
Vectors_bak:	blk.l $2E
DMACON_bak:	dc.w 0
INTENA_bak:	dc.w 0
Plane0_adr:	dc.l 0
Plane1_adr:	dc.l 0
Plane2_adr:	dc.l 0
Plane3_adr:	dc.l 0
AngleX:		dc.w 0
AngleY:		dc.w 0
PlaneBuffer_adr:	dc.l 0
Cop_adr:	dc.l 0
Coor2D_adr:	dc.l 0
Font8_adr:	incbin "sources:interpol3d/orion6.fnt"
Font8Mask_adr:	incbin "sources:interpol3d/orion6-mask.fnt"
Text_adr:	incbin "sources:interpol3d/interpol.txt"
GFX_name:		dc.b 'graphics.library',0
	even

PageStrt_adr:
	dc.w (SizeY-(Font3DHeight+8))/2,0	;1 page en bas
	dc.w 0,(SizeY-(Font3DHeight+8))/2	;1 page en haut
	dc.w 0,(SizeY-(Font3DHeight+8))/2	;1 page en haut
	dc.w (SizeY-(Font3DHeight+8))/2,0	;1 page en bas

Sinus_adr:
	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763,32767
Cosinus_adr:
	dc.w 32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763,32767

Scene_adr:
;I
	dc.w 20,40
	dc.w 20,80
	dc.w 50,80
	dc.w 50,0
;N
	dc.w 0,40
	dc.w 0,80
	dc.w 30,80
	dc.w 30,40
	dc.w 50,60
	dc.w 50,80
	dc.w 70,60
	dc.w 70,0
	dc.w 50,20
	dc.w 30,0
;T
	dc.w 0,40
	dc.w 30,40
	dc.w 30,80
	dc.w 60,80
	dc.w 60,40
	dc.w 70,40
	dc.w 70,0
	dc.w 30,0
;E
	dc.w 0,40
	dc.w 0,80
	dc.w 50,80
	dc.w 70,60
	dc.w 70,50
	dc.w 60,50
	dc.w 50,60
	dc.w 30,60
	dc.w 30,50
	dc.w 40,50
	dc.w 50,40
	dc.w 32,40
	dc.w 40,30
	dc.w 60,40
	dc.w 70,40
	dc.w 70,20
	dc.w 30,0
;R
	dc.w 0,40
	dc.w 0,80
	dc.w 30,80
	dc.w 30,60
	dc.w 50,80
	dc.w 70,80
	dc.w 70,55
	dc.w 60,45
	dc.w 70,40
	dc.w 70,20
	dc.w 30,0

	dc.w 30,40
	dc.w 50,40
	dc.w 50,30
	dc.w 35,25
	dc.w 30,30
;P
	dc.w 0,40
	dc.w 0,80
	dc.w 30,80
	dc.w 30,60
	dc.w 50,60
	dc.w 70,40
	dc.w 70,20
	dc.w 30,0

	dc.w 30,50
	dc.w 40,50
	dc.w 50,40
	dc.w 50,25
	dc.w 40,20
	dc.w 30,30
;O
	dc.w 0,40
	dc.w 0,80
	dc.w 50,80
	dc.w 70,60
	dc.w 70,20
	dc.w 30,0

	dc.w 20,60
	dc.w 40,60
	dc.w 50,50
	dc.w 50,30
	dc.w 30,20
	dc.w 20,32
;L
	dc.w 0,40
	dc.w 0,80
	dc.w 50,80
	dc.w 70,60
	dc.w 50,50
	dc.w 40,60
	dc.w 30,50
	dc.w 30,0

Lines_adr:
;I
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,0*4
;N
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,6*4
	dc.w 6*4,7*4
	dc.w 7*4,8*4
	dc.w 8*4,9*4
	dc.w 9*4,0*4
;T
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,6*4
	dc.w 6*4,7*4
	dc.w 7*4,0*4
;E
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,6*4
	dc.w 6*4,7*4
	dc.w 7*4,8*4
	dc.w 8*4,9*4
	dc.w 9*4,10*4
	dc.w 10*4,11*4
	dc.w 11*4,12*4
	dc.w 12*4,13*4
	dc.w 13*4,14*4
	dc.w 14*4,15*4
	dc.w 15*4,16*4
	dc.w 16*4,0*4
;R
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,6*4
	dc.w 6*4,7*4
	dc.w 7*4,8*4
	dc.w 8*4,9*4
	dc.w 9*4,10*4
	dc.w 10*4,0*4
	dc.w 11*4,12*4
	dc.w 12*4,13*4
	dc.w 13*4,14*4
	dc.w 14*4,15*4
	dc.w 15*4,11*4
;P
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,6*4
	dc.w 6*4,7*4
	dc.w 7*4,0*4
	dc.w 8*4,9*4
	dc.w 9*4,10*4
	dc.w 10*4,11*4
	dc.w 11*4,12*4
	dc.w 12*4,13*4
	dc.w 13*4,8*4
;O
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,0*4
	dc.w 6*4,7*4
	dc.w 7*4,8*4
	dc.w 8*4,9*4
	dc.w 9*4,10*4
	dc.w 10*4,11*4
	dc.w 11*4,6*4
;L
	dc.w 0*4,1*4
	dc.w 1*4,2*4
	dc.w 2*4,3*4
	dc.w 3*4,4*4
	dc.w 4*4,5*4
	dc.w 5*4,6*4
	dc.w 6*4,7*4
	dc.w 7*4,0*4

Square_adr:
	rept 16
	dc.l $FFFF0000
	endr

NOTSquare_adr:
	rept 16
	dc.l $0000FFFF
	endr

;table des Octant_adrs: y2-y1,x2-x1,Dx-Dy
;si <0 alors 0 si >=0 alors 1. Par exemple: 
;	y2-y1<0 	donc 1
;	x2-x1<0 	donc 1
;	Dx-Dy<0		donc 1
;le code Octant_adr est donc le .b qui se trouve a l'adresse Octant_adr+111
	
Octant_adr:
	dc.b 4	;000 y1<y2 x1<x2 Dx>Dy		 
	dc.b 0	;001 y1<y2 x1<x2 Dx<Dy
	dc.b 5	;010 y1<y2 x1>x2 Dx>Dy
	dc.b 2	;011 y1<y2 x1>x2 Dx<Dy
	dc.b 6	;100 y1>y2 x1<x2 Dx>Dy
	dc.b 1	;101 y1>y2 x1<x2 Dx<Dy	
	dc.b 7	;110 y1>y2 x1>x2 Dx>Dy	
	dc.b 3	;111 y1>y2 x1>x2 Dx<Dy
